/*******************************************************************
*  Kuvaus: Sairausvakuutuksen pivrahojen simuloimalli		       *
*******************************************************************/

/* 0. Yleisi vakioiden mrittelyj (l muuta nit!) */
%TuhoaGlobaalit;

%LET START = &OUT;

%LET MALLI = SAIRVAK;

%LET alkoi1&MALLI = %SYSFUNC(TIME());

/* 1. Mallia ohjaavat makromuuttujat */

%MACRO Aloitus;

/* Jos ohjelma ajetaan KOKO-mallin kautta, kytetn siell mriteltyj ohjaavien makromuuttujien arvoja */

%IF &START = 1 %THEN %DO;
	%LET TYYPPI = &TYYPPI_KOKO;
	%LET TULOKSET = 0;
%END;

/* Jos ohjelma ajetaan erillisajossa, kytetn alla sytettyj ohjaavien makromuuttujien arvoja */

%IF &START NE 1 %THEN %DO;

	/* Seuraavia vaiheita ei ajeta jos arvot annetaan tmn koodin ulkopuolelta (&EG = 1) */	

	%IF &EG NE 1 %THEN %DO;

	%LET AVUOSI = 2022;		* Aineistovuosi (vvvv);

	%LET LVUOSI = 2022;		* Lainsdntvuosi (vvvv);

	%LET TYYPPI = SIMUL;	* Parametrien hakutyyppi: SIMUL (vuosikeskiarvo) tai SIMULX (parametrit haetaan tietylle kuukaudelle);

	%LET LKUUK = 12;		* Lainsdntkuukausi, jos parametrit haetaan tietylle kuukaudelle;

	%LET AINEISTO = REK;	* Kytettv aineisto (PALV = Palveluaineisto, REK = Rekisteriaineisto) ;

	%LET TULOSNIMI_SV = sairvak_simul_&SYSDATE._1 ; * Simuloidun tulostiedoston nimi ;

	%LET SDATATULO = 0;  * Kytetnk SAIRVAK-mallissa datan tulotietoja = 1 vai laskennallisia tulotietoja = 0. 
					       Jos 1, niin kytetn datan tulotietoja tulosrt ja tuloprt, muuten
			               kytetn knteisfunktiolla mriteltyj tulotietoja. ;

	* Inflaatiokorjaus. Euro- tai markkamristen parametrien haun yhteydess suoritettavassa
	  deflatoinnissa kytettvn kertoimen voi sytt itse INF-makromuuttujaan
	  (HUOM! desimaalit erotettava pisteell .). Esim. jos yksi lainsdntvuoden euro on
	  aineistovuoden rahassa 95 sentti, syt arvoksi 0.95.
	  Simuloinnin tulokset ilmoitetaan aina aineistovuoden rahassa.
	  Jos puolestaan haluaa kytt automaattista inflaatiokorjausta, on vaihtoehtoja kaksi:
	  - Elinkustannusindeksiin (kuluttajahintaindeksi, ind51) perustuva inflaatiokorjaus: INF = KHI
	  - Ansiotasoindeksiin (ansio64) perustuva inflaatiokorjaus: INF = ATI ;

	%LET INF = 1.00; * Syt lukuarvo, KHI tai ATI;
	%LET PINDEKSI_VUOSI = pindeksi_vuosi; *Kytettv indeksien parametritaulukko;		

	* Ajettavat osavaiheet ; 

	%LET POIMINTA = 1;  	* Muuttujien poiminta (1 jos ajetaan, 0 jos ei);
	%LET TULOKSET = 1;		* Yhteenvetotaulukot (1 jos ajetaan, 0 jos ei);

	%LET LAKIMAK_TIED_SV = SAIRVAKlakimakrot;	* SAIRVAK-mallin lakimakrotiedoston nimi ;
	%LET LAKIMAK_TIED_TT = TTURVAlakimakrot;	* TTURVA-mallin lakimakrotiedoston nimi ;	
	%LET PSAIRVAK = psairvak; * Kytettvn SAIRVAK-mallin parametritiedoston nimi ;
	%LET PTTURVA = ptturva; * Kytettvn TTURVA-mallin parametritiedoston nimi ;

	* Tulostaulukoiden esivalinnat ; 

	%LET TULOSLAAJ = 1 ; 	 * Mikrotason tulosaineiston laajuus (1 = suppea, 2 = laaja (kaikki pohja-aineiston muuttujat)) ;
	%LET MUUTTUJAT = hsaiprva SAIRPR haiprva VANHPR pmkyt SAIRPR_TYONANT amkyt VANHPR_TYONANT hwmky ERITHOITR; * Taulukoitavat muuttujat (summataulukot) ;
	%LET YKSIKKO = 1;		 * Tulostaulukoiden yksikk (1 = henkil, 2 = kotitalous) ;
	%LET LUOK_HLO1 = ; * Taulukoinnin 1. henkilluokitus (jos YKSIKKO = 1)
							   Vaihtoehtoina: 
							     desmod (tulodesiilit, ekvivalentit tulot (modoecd), hlpainot)
							     ikavu (ikryhmt)
							     elivtu (kotitalouden elinvaihe)
							     koulas (koulutusaste)
							     soss (sosioekonominen asema)
							     rake (kotitalouden rakenne)
								 maakunta (NUTS3-aluejaon mukainen maakuntajako);
	%LET LUOK_HLO2 = ;		 * Taulukoinnin 2. henkilluokitus ;
	%LET LUOK_HLO3 = ;		 * Taulukoinnin 3. henkilluokitus ;

	%LET LUOK_KOTI1 = ; * Taulukoinnin 1. kotitalousluokitus (jos YKSIKKO = 2) 
							    Vaihtoehtoina: 
							     desmod (tulodesiilit, ekvivalentit tulot (modoecd), hlpainot)
							     ikavuv (viitehenkiln mukaiset ikryhmt)
							     elivtu (kotitalouden elinvaihe)
							     koulasv (viitehenkiln koulutusaste)
							     paasoss (viitehenkiln sosioekonominen asema)
							     rake (kotitalouden rakenne)
								 maakunta (NUTS3-aluejaon mukainen maakuntajako);
	%LET LUOK_KOTI2 = ; 	  * Taulukoinnin 2. kotitalousluokitus ;
	%LET LUOK_KOTI3 = ; 	  * Taulukoinnin 3. kotitalousluokitus ;

	%LET EXCEL = 0; 		 * Viednk tulostaulukko automaattisesti Exceliin (1 = Kyll, 0 = Ei) ;

	* Laskettavat tunnusluvut (jos tyhj, niin ei lasketa);

	%LET SUMWGT = SUMWGT; * N eli lukumrt ;
	%LET SUM = SUM; 
	%LET MIN = ; 
	%LET MAX = ;
	%LET RANGE = ;
	%LET MEAN = ;
	%LET MEDIAN = ;
	%LET MODE = ;
	%LET VAR = ;
	%LET CV =  ;
	%LET STD =  ;

	%LET PAINO = ykor ; 	* Kytettv painokerroin (jos tyhj, niin lasketaan painottamattomana) ;
	%LET RAJAUS =  ; 		* Rajauslause tunnuslukujen laskentaan (jos tyhj, niin ei rajauksia);

	%END;

	/* Lasketaan mahdollinen indeksiin perustuva inflaatiokorjaus */

	%InfKerroin(&AVUOSI, &LVUOSI, &INF);

%END;

/* Ajetaan lakimakrot ja tallennetaan ne */

%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_SV..sas";
%INCLUDE "&LEVY&KENO&HAKEM&KENO.MAKROT&KENO&LAKIMAK_TIED_TT..sas";

%MEND Aloitus;

%Aloitus;


/* 2. Datan poiminta ja apumuuttujien luominen (optio) */
%MACRO SairVak_Muut_Poiminta;

%IF &POIMINTA = 1 %THEN %DO;

	/* 2.1 Mritelln tarvittavat palveluaineiston muuttujat taulukkoon START_SAIRVAK */

	DATA STARTDAT.START_SAIRVAK;
	SET POHJADAT.&AINEISTO&AVUOSI
	(KEEP = hnro knro ppv ppvt tulosrt tuloprt haiprva hsaiprva pmkyt amkyt hwmky wpv
	muuperu aivpvkt aivpvt2 aivpvk aivpv2 aivpv1 aivpvt1 tosinktp

	SAIR_PVX SAIR_PER_PV VANH_PER_PV SAIR_TULO VANH_TULO SAIR_PV_TYONANT
	VANH_PV_TYONANT SAIRTULO_TYONANT VANHTULO_TYONANT ERITHOIT_PER_PV ERITHOIT_TULO ANSPALKKA);

	WHERE ppv > 0 OR ppvt > 0 OR tulosrt > 0 OR tuloprt > 0 OR haiprva > 0
	OR hsaiprva > 0 OR amkyt > 0 OR hwmky > 0 OR wpv > 0;


	LABEL 
	SAIR_PVX = 'Vakuutetun sairauspivrahapivt, DATA'
	SAIR_PER_PV = 'Vakuutetun sairauspivrahat piv kohden, DATA'
	VANH_PER_PV = 'Vakuutetun vanhempainpivrahat piv kohden, DATA'
	SAIR_TULO = 'Laskennallinen vakuutetun sairauspivrahan perusteena oleva tulo (e/v), DATA'
	VANH_TULO = 'Laskennallinen vakuutetun vanhemnpainpivrahan perusteena oleva tulo (e/v), DATA'
	SAIR_PV_TYONANT = 'Tynantajalle maksettu sairauspivraha piv kohden, DATA'
	VANH_PV_TYONANT = 'Tynantajalle maksettu vanhempainpivraha piv kohden, DATA'
	SAIRTULO_TYONANT = 'Laskennallinen tynantajalle maksettavan sairauspivrahan perusteena oleva tulo (e/v), DATA'
	VANHTULO_TYONANT = 'Laskennallinen tynantajalle maksettavanvanhemnpainpivrahan perusteena oleva tulo (e/v), DATA'
	ERITHOIT_PER_PV = 'Erityishoitoraha piv kohden, DATA'
	ERITHOIT_TULO = 'Erityishoitorahan perusteena oleva tulo (e/kk), DATA'
	ANSPALKKA = 'Johdettu palkka, kun pivrahan oletetaan perustuvan tyttmyysturvaan, DATA';

	RUN;
	
%END;

%MEND SairVak_Muut_Poiminta;

%SairVak_Muut_Poiminta;


/* 3. Simulointivaihe */

%LET alkoi2&malli = %SYSFUNC(TIME());

%MACRO SairVak_Simuloi_Data;

/* Muuttujat, joihin haetaan lista mallin kyttmist lakiparametreist */
%LOCAL SAIRVAK_PARAM SAIRVAK_MUUNNOS;

/* Haetaan mallin kyttmien lakiparametrien nimet */
%HaeLokaalit(SAIRVAK_PARAM, SAIRVAK);
%HaeLaskettavatLokaalit(SAIRVAK_MUUNNOS, SAIRVAK);

/* Luodaan tyhjt lokaalit muuttujat lakiparametien hakua varten */
%LOCAL &SAIRVAK_PARAM;

/* TTURVA-mallin parametrit */
/* Muuttujat, joihin haetaan lista mallin kyttmist lakiparametreist */
%LOCAL TTURVA_PARAM TTURVA_MUUNNOS;

/* Haetaan mallin kyttmien lakiparametrien nimet */
%HaeLokaalit(TTURVA_PARAM, TTURVA);
%HaeLaskettavatLokaalit(TTURVA_MUUNNOS, TTURVA);

/* Luodaan tyhjt lokaalit muuttujat lakiparametien hakua varten */
%LOCAL &TTURVA_PARAM;

/* Jos parametrit luetaan makromuuttujiksi ennen simulontia, ajetaan tm makro, erillisajossa */
%KuukSimul(SAIRVAK);
%KuukSimul(TTURVA);

/* Varsinainen simulointivaihe */

DATA TEMP.&TULOSNIMI_SV;
SET STARTDAT.START_SAIRVAK;

/* 3.1 Pivrahojen simulointi */

/* 3.1.1 Sairauspivrahat */

/* Simulointi laskennallisilla tulotiedoilla */
IF &SDATATULO NE 1 OR tulosrt = 0 THEN DO;
	%SairVakPRahaVS(SAIRPR, &LVUOSI, &INF, 0, 0, SAIR_TULO);
	%SairVakPRahaVS(SAIRPR_TYONANT, &LVUOSI, &INF, 0, 0, SAIRTULO_TYONANT);
END;

/* Vaihtoehtoisesti simulointi datan tulotiedoilla */
ELSE DO;
	/* Lainsdntvuodesta 2022 eteenpin ja 2019-2021 aineistolla */
	IF &LVUOSI >= 2022 AND 2019 <= &AVUOSI <= 2021 THEN DO; 
		%SairVakPRahaVS(SAIRPR, &LVUOSI, &INF, 0, 0, SUM(tulosrt, tosinktp) / (1 - &PalkVah));
		%SairVakPRahaVS(SAIRPR_TYONANT, &LVUOSI, &INF, 0, 0, SUM(tulosrt, tosinktp) / (1 - &PalkVah));
	END;
	/* Muulloin */
	ELSE DO;
		%SairVakPRahaVS(SAIRPR, &LVUOSI, &INF, 0, 0, tulosrt / (1 - &PalkVah));
		%SairVakPRahaVS(SAIRPR_TYONANT, &LVUOSI, &INF, 0, 0, tulosrt / (1 - &PalkVah));
	END;
END;

SAIRPR = SAIR_PVX * SAIRPR / &SPaivat;
SAIRPR_TYONANT = ppvt * SAIRPR_TYONANT / &SPaivat;

/* 3.1.2 Vanhempainpivrahat */

/* Simulointi laskennallisilla tulotiedoilla */
IF &SDATATULO NE 1 OR tuloprt = 0 THEN DO;
	/* Vakuutetulle maksetut */
	%VanhPRahaVS(AIT_VANH, &LVUOSI, &INF, 1, 0, 0, 0, VANH_TULO);
	%VanhPRahaVS(KOR_VANH, &LVUOSI, &INF, 0, 1, 0, 0, VANH_TULO);
	%VanhPRahaVS(NORMVANH, &LVUOSI, &INF, 0, 0, 1, 0, VANH_TULO);
	/* Tynantajalle maksetut */
	%VanhPRahaVS(AIT_VANH_TYONANT, &LVUOSI, &INF, 1, 0, 0, 0, VANHTULO_TYONANT);
	%VanhPRahaVS(KOR_VANH_TYONANT, &LVUOSI, &INF, 0, 1, 0, 0, VANHTULO_TYONANT);
	%VanhPRahaVS(NORMVANH_TYONANT, &LVUOSI, &INF, 0, 0, 1, 0, VANHTULO_TYONANT);
END;

/* Vaihtoehtoisesti simulointi datan tulotiedoilla */
ELSE DO;
	/* Lainsdntvuodesta 2022 alkaen ja 2019-2021 aineistolla */
	IF &LVUOSI >= 2021 AND 2019 <= &AVUOSI <= 2021 THEN DO;
		/* Vakuutetulle maksetut */
		%VanhPRahaVS(AIT_VANH, &LVUOSI, &INF, 1, 0, 0, 0, SUM(tuloprt, tosinktp) /(1 - &PalkVah));
		%VanhPRahaVS(KOR_VANH, &LVUOSI, &INF, 0, 1, 0, 0, SUM(tuloprt, tosinktp) / (1 - &PalkVah));
		%VanhPRahaVS(NORMVANH, &LVUOSI, &INF, 0, 0, 1, 0, SUM(tuloprt, tosinktp) / (1 - &PalkVah));
		/* Tynantajalle maksetut */
		%VanhPRahaVS(AIT_VANH_TYONANT, &LVUOSI, &INF, 1, 0, 0, 0, SUM(tuloprt, tosinktp) / (1 - &PalkVah));
		%VanhPRahaVS(KOR_VANH_TYONANT, &LVUOSI, &INF, 0, 1, 0, 0, SUM(tuloprt, tosinktp) / (1 - &PalkVah));
		%VanhPRahaVS(NORMVANH_TYONANT, &LVUOSI, &INF, 0, 0, 1, 0, SUM(tuloprt, tosinktp) / (1 - &PalkVah));
	END;
	/* Muulloin */
	ELSE DO;
		/* Vakuutetulle maksetut */
		%VanhPRahaVS(AIT_VANH, &LVUOSI, &INF, 1, 0, 0, 0, tuloprt /(1 - &PalkVah));
		%VanhPRahaVS(KOR_VANH, &LVUOSI, &INF, 0, 1, 0, 0, tuloprt / (1 - &PalkVah));
		%VanhPRahaVS(NORMVANH, &LVUOSI, &INF, 0, 0, 1, 0, tuloprt / (1 - &PalkVah));
		/* Tynantajalle maksetut */
		%VanhPRahaVS(AIT_VANH_TYONANT, &LVUOSI, &INF, 1, 0, 0, 0, tuloprt / (1 - &PalkVah));
		%VanhPRahaVS(KOR_VANH_TYONANT, &LVUOSI, &INF, 0, 1, 0, 0, tuloprt / (1 - &PalkVah));
		%VanhPRahaVS(NORMVANH_TYONANT, &LVUOSI, &INF, 0, 0, 1, 0, tuloprt / (1 - &PalkVah));
	END;
END;


/* Kerrotaan pivill */


AIT_VANH = aivpvk * AIT_VANH;
KOR_VANH = aivpv1 * KOR_VANH;
NORMVANH = aivpv2 * NORMVANH;
AIT_VANH_TYONANT = aivpvkt * AIT_VANH_TYONANT;
KOR_VANH_TYONANT = aivpvt1 * KOR_VANH_TYONANT;
NORMVANH_TYONANT =  aivpvt2 * NORMVANH_TYONANT;

/* 3.1.3 Erityishoitoraha */

IF wpv > 0 THEN DO;
	%VanhPRahaVS(ERITHOITR, &LVUOSI, &INF, 0, 0, 1, 0, ERITHOIT_TULO);
	ERITHOITR = wpv * ERITHOITR;
END;

VANHPR = SUM(NORMVANH, AIT_VANH, KOR_VANH);


/* Jos vanhempainpivraha perustuu tyttmyysturvaan (muuperu = "TT"), 
   johdetaan pivraha tyttmyyspivrahasta kyttmll apumuuttujaa ANSPALKKA.
   Huom! Tm sivuuttaa mahdollisesti aikaisemmin lasketut muuttujat NORMVANH, AIT_VANH ja KOR_VANH */

IF muuperu = "TT" THEN DO;
	%AnsioSidVS(ANSIOSID, &LVUOSI, &INF, 0, 0, 0, 0, ANSPALKKA, 0, 0, 0);
	VANHPR = SUM(aivpv1, aivpv2, aivpvk) * ANSIOSID / &SPaivat;
END;

VANHPR_TYONANT = SUM(NORMVANH_TYONANT, KOR_VANH_TYONANT, AIT_VANH_TYONANT);

* Asetetaan muuttujien 0-arvot tyhjiksi, jotta lukumrt voidaan laskea suoraan ;

ARRAY PISTE 
	hsaiprva SAIRPR haiprva VANHPR
	pmkyt SAIRPR_TYONANT amkyt
	VANHPR_TYONANT hwmky ERITHOITR
	AIT_VANH KOR_VANH NORMVANH AIT_VANH_TYONANT KOR_VANH_TYONANT NORMVANH_TYONANT;
DO OVER PISTE;
	IF PISTE <= 0 THEN PISTE = .;
END;

* Luodaan simuloiduille muuttujille selitteet ;

LABEL 
SAIRPR = 'Vakuutetuille maksetut sairauspivrahat, MALLI'
VANHPR = 'Vakuutetuille maksetut vanhempainpivrahat, MALLI'
AIT_VANH = 'Vakuutetuille maksetut korotetut itiys-/raskausrahapivrahat, MALLI'
KOR_VANH = 'Vakuutetuille maksetut korotetut vanhempainpivrahat, MALLI'
NORMVANH = 'Vakuutetuille maksetut korottamattomat vanhempainpivrahat, MALLI'
SAIRPR_TYONANT = 'Tynantajille maksetut sairauspivrahat, MALLI'
VANHPR_TYONANT = 'Tynantajille maksetut vanhempainpivrahat, MALLI'
AIT_VANH_TYONANT = 'Tynantajille maksetut korotetut itiys-/raskausrahapivrahat, MALLI'
KOR_VANH_TYONANT = 'Tynantajille maksetut korotetut vanhempainpivrahat, MALLI'
NORMVANH_TYONANT = 'Tynantajille maksetut korottamattomat vanhempainpivrahat, MALLI'
ERITHOITR = 'Erityishoitorahat, MALLI';

KEEP hnro SAIRPR VANHPR SAIRPR_TYONANT VANHPR_TYONANT ERITHOITR
	AIT_VANH KOR_VANH NORMVANH AIT_VANH_TYONANT KOR_VANH_TYONANT NORMVANH_TYONANT ;

RUN;

/* 3.2 Luodaan tulostiedosto OUTPUT-kansioon */

/* Tt vaihetta ei ajeta mikli osamallia kytetn KOKO-mallin kautta. */

%IF &START NE 1 %THEN %DO;

	/* Yhdistetn tulokset pohja-aineistoon */

	DATA TEMP.&TULOSNIMI_SV;
		
	/* 3.2.1 Suppea tulostiedosto (vain trkeimmt luokittelumuuttujat) */

	%IF &TULOSLAAJ = 1 %THEN %DO; 
		MERGE POHJADAT.&AINEISTO&AVUOSI 
		(KEEP = hnro knro &PAINO hsaiprva haiprva pmkyt amkyt hwmky ikavu ikavuv desmod soss paasoss elivtu koulas koulasv rake maakunta)
		TEMP.&TULOSNIMI_SV;
	%END;

	/* 3.2.2 Laaja tulostiedosto (kaikki pohja-aineiston muuttujat) */

	%IF &TULOSLAAJ = 2 %THEN %DO; 
		MERGE POHJADAT.&AINEISTO&AVUOSI TEMP.&TULOSNIMI_SV;
	%END;

	* Asetetaan muuttujien 0-arvot tyhjiksi, jotta lukumrt voidaan laskea suoraan ;

	ARRAY PISTE 
		hsaiprva haiprva pmkyt amkyt hwmky;
	DO OVER PISTE;
		IF PISTE <= 0 THEN PISTE = .;
	END;

	* Luodaan datan muuttujille selitteet ;

	LABEL 
	hsaiprva = 'Vakuutetuille maksetut sairauspivrahat, DATA'
	haiprva = 'Vakuutetuille maksetut vanhempainpivrahat, DATA'
	pmkyt = 'Tynantajille maksetut sairauspivrahat, DATA'
	amkyt = 'Tynantajille maksetut vanhempainpivrahat, DATA'
	hwmky = 'Erityishoitorahat, DATA';

	BY hnro;

	RUN;

	%IF &YKSIKKO = 2 AND &START ^= 1 %THEN %DO;
		%SumKotitT(OUTPUT.&TULOSNIMI_SV._KOTI, TEMP.&TULOSNIMI_SV, &MALLI, &MUUTTUJAT);

		PROC DATASETS LIBRARY=TEMP NOLIST;
			DELETE &TULOSNIMI_SV;
		RUN;
		QUIT;

	%END;

	/* Jos kyttj mritellyt YKSIKKO=1 (henkiltaso) tai YKSIKKO on mit tahansa muuta kuin 2 (kotitaloustaso)
		niin jtetn tulostaulu henkiltasolle ja nimetn se uudelleen */

	%ELSE %DO;
		PROC DATASETS LIBRARY=TEMP NOLIST;
			DELETE &TULOSNIMI_SV._HLO;
			CHANGE &TULOSNIMI_SV=&TULOSNIMI_SV._HLO;
			COPY OUT=OUTPUT MOVE;
			SELECT &TULOSNIMI_SV._HLO;
		RUN;
		QUIT;
	%END;

	/* Tyhjennetn TEMP-kirjasto */

	%IF &TEMPTYHJ = 1 %THEN %DO;
		PROC DATASETS LIBRARY=TEMP NOLIST KILL;
		RUN;
		QUIT;
	%END;

%END;

%MEND SairVak_Simuloi_Data;

%SairVak_Simuloi_Data;

%LET loppui2&malli = %SYSFUNC(TIME());


/* 4. Tulostetaan kyttjn pyytmt taulukot */

%MACRO KutsuTulokset;
	%IF &TULOKSET = 1 AND &YKSIKKO = 1 %THEN %DO;
		%KokoTulokset(1,&MALLI,OUTPUT.&TULOSNIMI_SV._HLO,1);
	%END;
	%IF &TULOKSET = 1 AND &YKSIKKO = 2 %THEN %DO;
		%KokoTulokset(1,&MALLI,OUTPUT.&TULOSNIMI_SV._KOTI,2);
	%END;
	
	/* Jos EG = 1 ja simulointia ei ajettu KOKOsimul-koodin kautta, palautetaan EG-makromuuttujalle oletusarvo */
	%IF &START ^= 1 and &EG = 1 %THEN %DO;
		%LET EG = 0;
	%END;
%MEND;
%KutsuTulokset;


/* 5. Mitataan kuinka kauan osavaiheisiin kului aikaa */

%LET loppui1&malli = %SYSFUNC(TIME());

%LET kului1&malli = %SYSEVALF(&&loppui1&malli - &&alkoi1&malli);

%LET kului2&malli = %SYSEVALF(&&loppui2&malli - &&alkoi2&malli);

%LET kului1&malli = %SYSFUNC(PUTN(&&kului1&malli, time10.2));

%LET kului2&malli = %SYSFUNC(PUTN(&&kului2&malli, time10.2));

%PUT &malli. Koko laskenta. Aikaa kului (hh:mm:ss.00) &&kului1&malli;

%PUT &malli. Varsinainen simulointi. Aikaa kului (hh:mm:ss.00) &&kului2&malli;
